// Otetaan käyttöön Jyväskylän yliopiston Jypeli-kirjasto
using Jypeli;

/// @author  Antti-Jussi Lakanen
/// @version 2025
///
/// <summary>
/// Luokka, jossa harjoitellaan piirtämistä lisäämällä ympyröitä ruudulle
/// </summary>
public class Lumiukko : PhysicsGame
{
    /// <summary>
    /// Piirretään objektit ja zoomataan kamera siten, että kenttä näkyy hyvin ruudulla.
    /// </summary>
    public override void Begin()
    {
      
        Level.Background.Color = Color.HotPink;

        GameObject alinPallo = new GameObject(200, 2 * 100.0, Shape.Circle);
        alinPallo.Y = Level.Bottom + 200.0;
        Add(alinPallo);

        GameObject keskipallo = new GameObject(alinPallo.Width/2, alinPallo.Height/2, Shape.Circle);
        keskipallo.Y = alinPallo.Y + alinPallo.Height / 2 + keskipallo.Height/2;
        Add(keskipallo);

        GameObject ylinPallo = new GameObject(keskipallo.Width/2, keskipallo.Height/2, Shape.Circle);
        ylinPallo.Y = keskipallo.Y + keskipallo.Height/2 + ylinPallo.Height/2;
        Add(ylinPallo);

        GameObject silmaVasen = new GameObject(2 * 5.0, 2 * 5.0, Shape.Star);
        silmaVasen.X = ylinPallo.X - ylinPallo.Width / 4;
        silmaVasen.Y = ylinPallo.Y;
        Add(silmaVasen);

        GameObject silmaOikea = new GameObject(2 * 5.0, 2 * 5.0, Shape.Triangle);
        silmaOikea.X = ylinPallo.X + 30.0 / 2;
        silmaOikea.Y = ylinPallo.Y;
        Add(silmaOikea);

        silmaVasen.Color = Color.Black;
        silmaOikea.Color = Color.Black;

        GameObject nena = new GameObject(2 * 3.0, 2 * 3.0, Shape.Circle);
        nena.Y = ylinPallo.Y - 30 / 3;
        Add(nena);
        nena.Color = Color.Black;

        GameObject suu = new GameObject(2 * 7.0, 2 * 3.0, Shape.Circle);
        suu.Y = ylinPallo.Y - 30 * 2 / 3;
        Add(suu);
        suu.Color = Color.Black;

        // Zoomataan kamera siten, että kaikki objektit näkyvät.
        // Objektien ympärille jätetään 100 yksikön marginaali. 
        Camera.ZoomToAllObjects(100);

        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }
}