using Jypeli;

/// @author  Antti-Jussi Lakanen, modified by (Oma nimesi).
/// @version 2025
/// 
/// <summary>
/// Ohjelma piirtää viisi neliötä (sivun pituus 80) siten, että
/// ensimmäisen neliön keskipiste on origossa, ja viimeisen
/// neliön keskipiste pisteeessä (320, 320).
/// </summary>
public class Portaat : PhysicsGame
{
    /// <summary>
    /// Aliohjelma piirtää ruutuun yhden neliön, jonka
    /// sivun pituus on 80, ja keskipiste on (x, y).
    /// </summary>
    /// <param name="x">Neliön keskipisteen x-koordinaatti.</param>
    /// <param name="y">Neliön keskipisteen y-koordinaatti.</param>
    public void PiirraNelio(double x, double y)
    {
        PhysicsObject nelio = new PhysicsObject(80, 80);
        nelio.X = x;
        nelio.Y = y;
        Add(nelio);
    }

    /// <summary>
    /// Kutsutaan PiirraNeliota muutaman kerran.
    /// </summary>
    public override void Begin()
    {
        Camera.ZoomToLevel();
        PiirraNelio(0, 0);
        PiirraNelio(80, 80);
        PiirraNelio(160, 160);
        PiirraNelio(240, 240);
        PiirraNelio(320, 320);
        Camera.ZoomToAllObjects(50);
    }
}