# Tehtävä 7

## Kohdat a, b, c, d

```
a)             b)            c)             d)
   0101 1111      0101 1111      0000 0001     1111 1111
  +0001 1111     +0101 1111     +1111 1111    +1111 1111
  ----------     ----------     ----------    ----------
   0111 1110      1011 1110      0000 0000     1111 1110
```

## Kohta e

a)  95 +  31  = 126  
b)  95 +  95  = 190  
c)   1 + 255  =   0  
d) 255 + 255  = 254

## Kohta f

a) 95 + 31 = 126  
b) 95 + 95 = -66  
c)  1 + -1 =   0  
d) -1 + -1 =  -2

## Kohta g

(e)-kohdan tapauksessa oikean tuloksen antavat kohdat `b d`

## Kohta h

(f)-kohdan tapauksessa oikean tuloksen antavat kohdat `a c d`

## Kohta i

```
 1000 0000  = -128
+1000 0001  = -127
 ----------
 0000 0001  = 1
```

# Tehtävä 7j

Virheellisen tuloksen huomaaminen riippuu siitä, onko 2-komplementti käytössä vai ei.

**Jos 2-komplementti ei ole käytössä**, virheellisen tuloksen sääntö on helppo:  

> Jos eniten merkitseviä bittiä (eli vasemalla olevia bittiä) summatessa
> muistiin jäävä eniten merkitsevä bitti on 1, tulos on väärin.

Palataan 7c-kohtaan, mutta kirjataan ylös muistiin jäävät bitit jokaisen summan jälkeen:

```
"Muistiin" jäävä osa: 11111 111
1. luku                0000 0001 = 1
2. luku               +1111 1111 = 255
                       ---------
                       0000 0000 = 0

Merkitsevin muistiin jäävä bitti (eli "eniten vasemalla" oleva): 1 => YLIVUOTO
```

**Jos 2-komplementti on käytössä**, sääntö on vaikeampi:

> Jos summatessa **kaksi** eniten merkitsevää muistiin jäänyttä bittiä ovat eri, tulos on väärin.

Tässä vielä kaksi esimerkkiä

```
"Muistiin" jäävä osa: 01011 111
1. luku                0101 1111 = 95
2. luku               +0101 1111 = 95
                       ---------
                       1011 1110 = -66

Kaksi eniten merkitsevää muistiin jäävää bittiä: 0 ja 1 => YLIVUOTO
```

```
"Muistiin" jäävä osa: 10000 000
1. luku                1000 0000 = -128
2. luku               +1000 0001 = -127
                       ---------
                       0000 0001 = 1

Kaksi eniten merkitsevää muistiin jäävää bittiä: 1 ja 0 => YLIVUOTO
```

*Vaihtoehtoinen sääntö on:* Jos kummankin luvun eniten merkitsevä bitti on
sama ja summan eniten merkitsevä bitti on eri, tulos on väärin. Eli jos kahden
luvun MSB on 0 ja summan MSB on 1, tulos on virheellinen. Vastaavasti, jos
kahden luvun MSB on 1 ja summan MSB on 0, tulos on myös virheellinen.
Selkokielellä: jos summattavat luvut ovat kummatkin "samanmerkkiset" (eli
kummatkin positiiviset/negatiiviset) ja summa on erimerkkinen, tulos on
virheellinen.
 
Yleisesti tällöin puhutaan "ylivuodosta" (eng. overflow): lukujen summa on
niin paljon suurempi kuin mitä muistiin mahtuu, että luku "vuotaa" yli sille
varatun muistialueen.
 
## Bonustietoa

Useimmissa prosessoreissa kokonaislukuja summatessa eniten merkitsevistä
biteistä lasketaan ylivuotoehto yllä kerrotulla muistisäännöllä, ja tulos
tallennetaan omaan muistialueeseen. Tällöin prosessorissa ajettava ohjelma voi
tarkistaa jokaisen laskun jälkeen, tapahtuiko ylivuoto.
 
Esimerkiksi x86 ja AMD64/Intel64 -prosessoreissa tätä muistialuetta kutsutaan
ylivuotolipuksi (overflow flag):
[AMD64 spesifikaatio](https://www.amd.com/system/files/TechDocs/24592.pdf), sivut 34 ja 36.

Puolestaan useimmissa ARM-prosessoreissa puhutaan yleisesti
ehtolipuista (condition flags): [ARM spesifikaatio](http://infocenter.arm.com/help/index.jsp?topic=/com.arm.doc.dui0801a/CIAGACJE.html).

C#:ssa ylivuodon tarkastus tapahtuu ohjelman kääntämisen aikana, mutta ei ajon
aikana, sillä jatkuva ylivuodon tarkistus voi hidastaa
ohjelmaa (tosin ei valtavasti: esimerkiksi x64-prosessoreilla 
[ylivuuototarkistus lisää vain yhden lisäkäskyn jokaisen laskun loppuun](https://sharplab.io/#v2:EYLgxg9gTgpgtADwGwBYA0AXEBDAzgWzQBMQBqAHwAEAmARgFgAoSgZgAIa2BhNgbybaC2Aoaw4o2AVQB2YABYwwAaxhEAgkSIAKAJR9hjIUba5gATwww22NgF42ABmAPargPqvXAbhHGT5yzZgO0dnTw9PH0M/DloATjYtbB0omNiErWAU32NKeMStUwsYHSTSLOzowQBfHJyxSgkuBWVVDW09firjeUUVIhyjLrSjIsCbeycXd09aVJHBMatgybCZyMGYvIzk+YXtxKy9kYOtQoCSsorjo1ruu+qgA)). 

Esimerkiksi:
```csharp
sbyte a = 0b0111_1111;
sbyte b = 0b0111_1111;
Console.WriteLine (a);
Console.WriteLine (b);
Console.WriteLine ((sbyte)(a+b));
```

Ohjelma kääntyy ja tulostaa

```
127
127
-2
```

Jos haluaa ylivuototarkistuksen päälle myös ajon aikana, pitää
"ongelmakoodi" laittaa `checked`-lohkoon:

```csharp
checked
{
    sbyte a = 0b0111_1111;
    sbyte b = 0b0111_1111;
    Console.WriteLine (a);
    Console.WriteLine (b);
    Console.WriteLine ((sbyte)(a+b));
}
```

Siinä tapauksessa ohjelma tulostaa virheen yhteenlaskun kohdalla

```
127
127

Unhandled Exception:
System.OverflowException: Arithmetic operation resulted in an
overflow.
 ```

## Lisätietoa

* [C-Jump: Overflow detection](http://www.c-jump.com/CIS77/CPU/Overflow/lecture.html)
