using System;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Ohjelmassa lasketaan kertotauluja, harjoitellaan 
/// silmukoiden käyttöä.
/// </summary>
public class Kertotaulut
{
    /// <summary>
    /// Aliohjelmakutsut.
    /// </summary>
    public static void Main()
    {
        TulostaKertotauluFor(3);
        Console.WriteLine("-------------------");
        TulostaKertotauluWhile(3, 5);
        Console.WriteLine("-------------------");
        TulostaKertotauluDoWhile(6, 0);
    }

    /// <summary>
    /// Tulostetaan annetun luvun kertotaulu kokonaisluvuilla 1..10.
    /// </summary>
    /// <param name="kerrottava">Minkä luvun kertotaulu tulostetaan.</param>
    public static void TulostaKertotauluFor(int kerrottava)
    {
        // Tämä yksi niitä harvoja tilanteita, kun silmukka aloitetaan jostain muusta kuin
        // indeksistä nolla. Miksikö? Kokeilepa tulostaa alla oleva "i+1":n arvoilla.
        for (int i = 1; i <= 10; i++)
        {
            Console.WriteLine($"{i,2} * {kerrottava} = {i * kerrottava,2}");
            // TAI 
            // Console.WriteLine("{0,2} * {1} = {2,3}", i, kerrottava, i * kerrottava);
            // TAI
            // Console.WriteLine(i + " * " + kerrottava + " = " + i * kerrottava);
        }

        // for (int i = 0; i < 10; i++)
        // {
        //     Console.WriteLine((i + 1) + " * " + kerrottava + " = " + (i + 1) * kerrottava);
        // }
    }

    /// <summary>
    /// Tulostetaan annetun luvun kertotaulu 
    /// alkaen ykkosesta ja paattyen annettuun lukuun.
    /// </summary>
    /// <param name="kerrottava">Minkä luvun kertotaulu tulostetaan.</param>
    /// <param name="mihinSaakka">Mihin saakka kerrotaan annettua lukua.</param>
    public static void TulostaKertotauluWhile(int kerrottava, int mihinSaakka)
    {
        int i = 1;
        while (i <= mihinSaakka)
        {
            Console.WriteLine($"{i,2} * {kerrottava} = {i * kerrottava,2}");
            i++;
        }
    }

    /// <summary>
    /// Tulostetaan annetun luvun kertotaulu kayttaen do-while -silmukkaa
    /// alkaen ykkosesta ja paattyen annettuun lukuun.
    /// </summary>
    /// <param name="kerrottava">Minkä luvun kertotaulu tulostetaan.</param>
    /// <param name="mihinSaakka">Mihin saakka kerrotaan annettua lukua.</param>
    public static void TulostaKertotauluDoWhile(int kerrottava, int mihinSaakka)
    {
        // Tällaisen ehdon voisi tehdä mikäli do-while-silmukkarakennetta ei voisi jostain syystä muuttaa.
        // Tämä EI ole suositeltava tapa!
        if (mihinSaakka < 1) return;
        int i = 1;
        do
        {
            Console.WriteLine($"{i,2} * {kerrottava} = {i * kerrottava,2}");
            i++;
        } while (i <= mihinSaakka);
    }
}
