using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Lisätään jonon alkuun ja loppuun
/// </summary>
public class MuuttuvaJono
{
    /// <summary>
    /// Lisätään jonon alkuun ja loppuun teksti
    /// </summary>
    public static void Main()
    {
        StringBuilder jono;
        jono = new StringBuilder("kissa istuu");
        LisaaAlkuunJaLoppuun(jono, "***");
        Console.WriteLine("Jono on nyt " + jono); // tulostaa *** kissa istuu ***
    }


    /// <summary>
    /// Lisätään jonon alkuun ja loppuun sama teksti
    /// </summary>
    /// <param name="jono">Mihin jonoo lisätään</param>
    /// <param name="lisattava">mitä lisätään</param>
    /// <example>
    /// <pre name="test">
    /// StringBuilder j1 = new StringBuilder("kissa istuu");
    /// LisaaAlkuunJaLoppuun(j1,"***");
    /// j1.ToString() === "*** kissa istuu ***";
    /// StringBuilder j2 = new StringBuilder("123");
    /// LisaaAlkuunJaLoppuun(j2,"XX");
    /// j2.ToString() === "XX 123 XX";
    /// StringBuilder j3 = new StringBuilder("");
    /// LisaaAlkuunJaLoppuun(j3,"X");
    /// j3.ToString() === "X  X";
    /// </pre>
    /// </example>
    public static void LisaaAlkuunJaLoppuun(StringBuilder jono, string lisattava)
    {
        jono.Insert(0, " ");
        jono.Insert(0, lisattava);
        jono.Append(" ");
        jono.Append(lisattava);
    }
}
