using System;
using System.Text;

/// @author  Vesa Lappalainen, Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Ohjelmassa kysytään käyttäjältä lause ja vaihdetaan 
/// kirjaimia toisiksi.
/// </summary>
public class KirjaintenMuutos
{
    /// <summary>
    /// Pyydetään käyttäjältä lause ja kutsutaan aliohjelmaa,
    /// joka muuttaa merkit. Lopuksi tulostetaan.
    /// </summary>
    /// <param name="args">Komentoriviparametrit (ei käytössä)</param>
    public static void Main()
    {
        char mika = 's';
        char miksi = 't';
        Console.WriteLine(MuutaKirjaimet("Toistan mitä sanot, mutta en osaa sanoa kirjainta " + mika + "!", mika, miksi));
        Console.Write("Anna lause  >");
        string lause = Console.ReadLine();
        string muutettulause = MuutaKirjaimet(lause, mika, miksi);
        Console.WriteLine(MuutaKirjaimet("Sanoit siis :", mika, miksi) + muutettulause);
        Console.ReadKey();
    }


    /// <summary>
    /// Aliohjelmassa korvataan annetun merkkijonon kaikki 
    /// pienet ja isot valitut (mika) kirjaimet kirjaimet vastaavilla
    /// miksi-kirjaimilla.
    /// </summary>
    /// <param name="lause">Muutettava lause</param>
    /// <param name="mika">Mikä kirjain muutetaan</param>
    /// <param name="miksi">Miksi kirjaimeksi muutetaan</param>
    /// <returns>Muutettu lause</returns>
    /// <example>
    /// <pre name="test">
    /// MuutaKirjaimet("Ralliauto ajaa superkovaa.",'r','l') === "Lalliauto ajaa supelkovaa."
    /// MuutaKirjaimet("Ralli-Kimi laulaa rokkia",'r','l') === "Lalli-Kimi laulaa lokkia"
    /// MuutaKirjaimet("Kissa istuu puussa",'r','l') === "Kissa istuu puussa"
    /// MuutaKirjaimet("Kissa istuu puussa",'S','t') === "Kitta ittuu puutta"
    /// </pre>
    /// </example>
    public static string MuutaKirjaimet(string lause, char mika, char miksi)
    {
        StringBuilder uusilause = new("");
        for (int i = 0; i < lause.Length; i++)
        {
            if (lause[i] == char.ToLower(mika)) uusilause.Append(char.ToLower(miksi));
            else if (lause[i] == char.ToUpper(mika)) uusilause.Append(char.ToUpper(miksi));
            else uusilause.Append(lause[i]);
        }
        return uusilause.ToString();
    }
}
