﻿using System;

namespace Demo5
{
    /// @author  Vesa Lappalainen, Antti-Jussi Lakanen
    /// @version 2025
    /// 
    /// <summary>
    /// Elämäpelin testipääohjelma.
    /// <see cref="Sopulit">Katso: Sopulit.cs</see>
    /// </summary>
    public class SopulitPaa
    {
        /// <summary>
        /// Katsotaan muutama kierros elämäpeliä
        /// </summary>
        /// <param name="args"></param>
        public static void Main()
        {
            int[,] alkuSukupolvi = {
               { 1,0,1,1 },
               { 0,1,1,0 },
               { 1,0,0,0 },
               { 1,0,0,1 }
             };



            int[,] seuraava = (int[,])alkuSukupolvi.Clone();
            Console.WriteLine(Sopulit.Jonoksi(alkuSukupolvi, " ", "\n", "[ {0} ]"));
            Console.WriteLine("====================");

            for (int i = 0; i < 3; i++)
            {
                seuraava = Sopulit.MuodostaUusiSukupolvi(seuraava);
                Console.WriteLine(Sopulit.Jonoksi(seuraava, " ", "\n", "[ {0} ]"));
                Console.WriteLine();
            }

            Console.WriteLine("====================");

            seuraava = (int[,])alkuSukupolvi.Clone();
            for (int i = 0; i < 3; i++)
            {
                Sopulit.SeuraavaSukupolvi(seuraava);
                Console.WriteLine(Sopulit.Jonoksi(seuraava, " ", "\n", "[ {0} ]"));
                Console.WriteLine();
            }
            Console.ReadKey();
        }
    }
}
