using System;
using System.Text;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Taulukkoa käsitteleviä aliohjelmia
/// </summary>
public class T5_TulostaYli
{
    /// <summary>
    /// Kutsutaan taulukkoa käsitteleviä aliohjelmia
    /// </summary>
    public static void Main()
    {
        int[] luvut = { 12, 3, 5, 9, 7, 1, 4, 9 };
        TulostaYli(luvut, 4);
    }

    /// <summary>
    /// Tulostetaan ne luvut, jotka ylittävät rajan
    /// </summary>
    /// <param name="luvut">taulukko joista ylittäviä etsitään</param>
    /// <param name="raja">minkä rajan lukujen täytyy ylittää</param>
    public static void TulostaYli(int[] taulukko, int raja)
    {
        for (int i = 0; i < taulukko.Length; i++)
        {
            if (taulukko[i] > raja)
            {
                Console.Write(taulukko[i] + " ");
            }
        }
    }

    /// <summary>
    /// EXTRA: Tulostetaan ne luvut, jotka ylittävät rajan käyttäen 
    /// erillistä funktiota `Jonoksi` joka muodostaa halutun merkkijonon.
    /// Tällä tavalla sitten testaaminen on mahdollista. 
    /// </summary>
    /// <param name="luvut">taulukko joista ylittäviä etsitään</param>
    /// <param name="raja">minkä rajan lukujen täytyy ylittää</param>
    public static void TulostaYli2(int[] luvut, int raja)
    {
        string s = Jonoksi(luvut, " ", raja);
        Console.WriteLine(s);
    }

    /// <summary>
    /// Muutetaan merkkijonoksi kaikki luvut jotka ylittävät rajan.
    /// Lukujen välisen erotinmerkin voi päättää.
    /// </summary>
    /// <param name="luvut"></param>
    /// <param name="erotin"></param>
    /// <param name="raja"></param>
    /// <returns>Taulukko jonona</returns>
    /// <example>
    /// <pre name="test">
    /// int[] luvut = {3,5,1};
    /// Jonoksi(luvut) === "3 5 1";
    /// Jonoksi(luvut,",") === "3,5,1";
    /// Jonoksi(luvut," ",1) === "3 5";
    /// Jonoksi(luvut," ",3) === "5";
    /// Jonoksi(luvut," ",5) === "";
    /// </pre>
    /// </example>
    public static string Jonoksi(int[] luvut, string erotin = " ", int raja = int.MinValue)
    {
        StringBuilder tulos = new StringBuilder();
        string vali = "";
        foreach (int luku in luvut)
            if (luku > raja)
            {
                tulos.Append(vali + luku);
                vali = erotin;
            }
        return tulos.ToString();
    }
}