using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// <summary>
/// Tehtävät 4-6 sekä Bonus 1.
/// </summary>
public class T4_6_Keskiarvo
{
    /// <summary>
    /// Keskiarvo muutamalla eri tavalla
    /// </summary>
    public static void Main()
    {
        // Tehtävä 4
        int[] luvut = { 10, 3, 5, 7, 12, 105, 10, 2, -1, 15, 20 };
        double keskiarvo = Keskiarvo4(luvut);
        Console.WriteLine($"Keskiarvo4 on {keskiarvo}.");

        // Tehtävä 5
        luvut = new int[] { 10, 3, 5, -1, 15, 20 };
        keskiarvo = Keskiarvo5(luvut);
        Console.WriteLine($"Keskiarvo5 on {keskiarvo}.");

        // Tehtävä 6
        int minimi = 3;
        luvut = new int[] { 11, 4, 2, 6 };
        keskiarvo = Keskiarvo6(luvut, minimi);
        Console.WriteLine($"Keskiarvo6 on {keskiarvo}.");
        
        // Bonus 1, esimerkki 1
        minimi = -7;
        int maksimi = 99;
        luvut = new int[] { -5, 1, -4, 0, 98 };
        keskiarvo = KeskiarvoB1(luvut, minimi, maksimi);
        Console.WriteLine($"KeskiarvoB1 on {keskiarvo}.");
        
        // Bonus 1, esimerkki 2
        minimi = 3;
        maksimi = 99;
        luvut = new int[] { 11, 4, 2, 6, 99, 12, 0, -3 };
        keskiarvo = KeskiarvoB1(luvut, minimi, maksimi);
        Console.WriteLine($"KeskiarvoB1 on {keskiarvo}.");
    }


    /// <summary>
    /// Lukujen keskiarvo
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <returns>Keskiarvo4</returns>
    public static double Keskiarvo4(int[] luvut)
    {
        if (luvut.Length == 0) return 0;
        int summa = 0;
        for (int i = 0; i < luvut.Length; i++)
        {
            summa += luvut[i];
        }

        return summa * 1.0 / luvut.Length;
    }

    /// <summary>
    /// Lukujen keskiarvo. Jos aineistossa tulee vastaan
    /// negatiivinen luku, palautetaan keskiarvo siihen
    /// asti käsitellyistä luvuista.
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <returns>Keskiarvo4</returns>
    public static double Keskiarvo5(int[] luvut)
    {
        if (luvut.Length == 0) return 0;
        int summa = 0;
        int laskuri = 0;
        foreach (int arvio in luvut)
        {
            if (arvio < 0) break;
            summa += arvio;
            laskuri++;
        }

        if (laskuri == 0) return 0.0;
        return summa / (double)laskuri;
    }

    /// <summary>
    /// Lukujen keskiarvo. Jos aineistossa tulee vastaan luku, joka on pienempi tai yhtäsuuri kuin
    /// kyseinen minimi-arvo, se hylätään, mutta aineiston käsittelyä kuitenkin jatketaan.
    /// Jos aineisto ei sisällä yhtään sopivaa lukua, tulee funktion palauttaa minimi-parametrin arvo.
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <param name="minimi">Minimi</param>
    /// <returns></returns>
    /// <example>
    /// <pre name="test">
    /// Keskiarvo6([1, 2, 3, 4, 5], 0) === 3.0;
    /// Keskiarvo6([2, 4, 6, -8, 10], 0) === 4.0;
    /// Keskiarvo6([-5, -10, -15], -11) === -7.5;
    /// Keskiarvo6([], 0) === 0.0
    /// Keskiarvo6([42], 0) === 42.0;
    /// Keskiarvo6([100, 100, 100], 0) === 100.0;
    /// Keskiarvo6([5, 4, 3, 2, 1], 3) === 4.5;
    /// Keskiarvo6([7, 7, 7], 7) === 7.0;
    /// </pre>
    /// </example>
    public static double Keskiarvo6(int[] luvut, int minimi)
    {
        if (luvut.Length == 0) return 0;
        int summa = 0;
        int laskuri = 0;
        foreach (int arvio in luvut)
        {
            if (arvio <= minimi) continue;
            summa += arvio;
            laskuri++;
        }

        if (laskuri == 0) return minimi;
        return summa / (double)laskuri;
    }
    
    
    /// <summary>
    /// Keskiarvo. Muuten sama kuin versio 6, mutta
    /// jos aineistossa tulee vastaan luku, joka on vähintään yhtä suuri kuin
    /// kyseinen maksimiarvo, aineiston käsittely päättyy siihen.
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <param name="minimi">Minimi (eksklusiivinen)</param>
    /// <param name="maksimi">Maksimi (eksklusiivinen)</param>
    /// <returns>Keskiarvo</returns>
    public static double KeskiarvoB1(int[] luvut, int minimi, int maksimi)
    {
        if (luvut.Length == 0) return 0;
        int summa = 0;
        int laskuri = 0;
        foreach (int luku in luvut)
        {
            if (luku <= minimi) continue;
            if (luku >= maksimi) break;
            summa += luku;
            laskuri++;
        }

        if (laskuri == 0) return minimi;
        return summa / (double)laskuri;
    }
}