using System;
using System.Text;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Demo 7, tehtävät B1-3.
/// Kiva joulukuusi (vaikka ei joulu olekaan.)
/// </summary>
public class B123_Kuusi
{
    /// <summary>
    /// Interaktio käyttäjän kanssa ja piirto.
    /// </summary>
    public static void Main()
    {
        // Bonus 1
        string puu = LuoPuu(9, '@', '|');
        Console.WriteLine(puu);

        // Bonus 2-3
        Random random = new Random();
        int jalanLeveys = 3;
        Console.Write("Miten levea puu > ");
        int korkeus = Math.Max(3, int.Parse(Console.ReadLine()));
        Console.Write("Kolmion merkki > ");
        char kolmio = Console.ReadKey().KeyChar;
        Console.WriteLine();
        Console.Write("Jalan merkki > ");
        char jalka = Console.ReadKey().KeyChar;
        Console.WriteLine();

        string kuusipuu = LuoPuu(jalanLeveys, korkeus, kolmio, jalka);
        Console.WriteLine(kuusipuu);
    }


    /// <summary>
    /// Piirrä kuusi.
    /// </summary>
    /// <param name="jalanLeveys">Jalan leveys</param>
    /// <param name="korkeus">Puun korkeus</param>
    /// <param name="puunMerkki">Puun merkki</param>
    /// <param name="jalanMerkki">Jalan merkki</param>
    /// <returns></returns>
    public static string LuoPuu(int jalanLeveys, int korkeus, char puunMerkki, char jalanMerkki)
    {
        Random random = new Random();
        StringBuilder puu = new StringBuilder();
        int leveys = 2 * korkeus;
        for (int i = 0; i < korkeus; i++)
        {
            StringBuilder rivi = new StringBuilder();
            rivi.Append(' ', leveys / 2 - i);
            rivi.Append(KolmionRivi(puunMerkki, i * 2 + 1, random)); // Luodaan loput rivistä.
            puu.Append(rivi);
            puu.AppendLine();
        }
        // Jalka
        puu.Append(' ', leveys / 2 - jalanLeveys / 2);
        puu.Append(jalanMerkki, jalanLeveys);
        return puu.ToString();
    }


    /// <summary>
    /// Luo "tavallinen puu" (Tehtävä Bonus 1). 
    /// </summary>
    /// <param name="leveys">Puun leveys.</param>
    /// <param name="lehdet">Lehden merkki.</param>
    /// <param name="jalka">Jalan merkki.</param>
    /// <returns>Puu.</returns>
    public static string LuoPuu(int leveys, char lehdet, char jalka)
    {
        StringBuilder sb = new StringBuilder();
        /* TAPA 1 */


        for (int i = 0; i < leveys / 2 + 1; i++)
        {
            sb.Append(' ', leveys / 2 - i);
            sb.Append(lehdet, (i * 2) + 1); // Rivi 0-->1, Rivi 1-->3, Rivi 2-->5, ...
            sb.Append('\n');
        }

        /* TAPA 2 */
        /*
        for (int i = 1; i <= leveys; i+=2)
        {
            sb.Append(' ', (leveys - i) / 2);
            sb.Append(lehdet, i);
            sb.Append(' ', (leveys - i) / 2);
            sb.Append('\n');
        }
        */

        // Jalka
        sb.Append(' ', leveys / 2 - 1);
        sb.Append(jalka, 3);
        return sb.ToString();
    }


    /// <summary>
    /// Apufunktio rivin rakentamista varten.
    /// Tekee keskimäärin 20% merkeistä o:ksi
    /// eli koristeita kuuseen.
    /// </summary>
    /// <param name="merkki">Millä merkillä täytetään</param>
    /// <param name="pituus">rivin pituus</param>
    /// <param name="r">Random-olio</param>
    /// <returns>Rivi kolmiota (eli puuta) varten.</returns>
    public static string KolmionRivi(char merkki, int pituus, Random r)
    {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < pituus; i++)
        {
            if (r.NextDouble() < 0.8) sb.Append(merkki);
            else sb.Append('o');
        }
        return sb.ToString();
    }
}
