/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Demo 7, tehtävä 3.
/// </summary>
public class T3_SanojenPituus
{
    /// <summary>
    /// Tyhjä.
    /// </summary>
    public static void Main()
    {
    }

    /// <summary>
    /// Sanojen pituuksien keskiarvo. Sanat erotellaan välilyöntien,
    /// pilkkujen ja pisteiden kohdilta. 
    /// </summary>
    /// <param name="jono">Tutkittava merkkijono.</param>
    /// <returns>Keskiarvo.</returns>
    /// <example>
    /// <pre name="test">
    /// SanojenPituusKeskiarvo("Kolme miestä istuu saunassa.") === 6;
    /// SanojenPituusKeskiarvo("Kolme miestä istuu saunassa") === 6;
    /// SanojenPituusKeskiarvo("Kolme  miestä  istuu  saunassa") === 6;
    /// SanojenPituusKeskiarvo("Kolme miestä, myös Pertti, istuskeleepi lauteilla.") === 7;
    /// SanojenPituusKeskiarvo("Kolmemiestäistuusaunassa") === 24;
    /// SanojenPituusKeskiarvo("Kolmemiestäistuusaunassa.") === 24;
    /// SanojenPituusKeskiarvo("") === 0;
    /// SanojenPituusKeskiarvo(" .,") === 0;
    /// </pre>
    /// </example>
    public static double SanojenPituusKeskiarvo(string jono)
    {
        // Huomautus! Oikeassa ohjelmassa välimerkit olisi syytä parametrisoida,
        // ts. olla tämän funktion parametrina. Nyt ne ovat tässä "kovakoodattu". 
        string[] sanat = jono.Split(new char[] { ' ', ',', '.' });
        int summa = 0;
        int sanoja = 0;
        foreach (string sana in sanat)
        {
            if (sana.Length > 0) sanoja++;
            summa += sana.Length;
        }
        if (sanoja == 0) return 0;
        return 1.0 * summa / sanoja;
    }
}
