using System;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Ohjelma perättäisten klaavojen laskemiseen kolikonheitossa.
/// </summary>
public class B1_KolikonHeitto
{
    /// <summary>
    /// Satunnaisten lukujen tekemiseen tarvittava muuttuja.
    /// Tämän tulee olla muuttuja, jota ei luoda new-sanalla
    /// uudestaan ohjelman kuluessa.
    /// </summary>
    static readonly Random random = new Random();

    /// <summary>
    /// Pääohjelma.
    /// </summary>
    public static void Main()
    {
        Console.WriteLine("Tervetuloa kolikonheittopeliin!");
        Console.Write("Montako perättäistä klaavaa halutaan? > ");
        int montakoPerattaista = int.Parse(Console.ReadLine());
        Console.Write("Montako kertaa haluat tuloksen? > ");
        int montakoKertaa = int.Parse(Console.ReadLine());

        int heittojaYhteensa = 0;

        for (int i = 0; i < montakoKertaa; i++)
        {
            heittojaYhteensa += MontakoHeittoaTarvitaan(montakoPerattaista);
        }

        double keskimaarainenHeittojenMaara = (double)heittojaYhteensa / montakoKertaa;
        
        Console.WriteLine($"{montakoPerattaista} perättäistä klaavaa {montakoKertaa} kertaa saatiin {heittojaYhteensa} heitolla.");

        Console.WriteLine($"Keskimäärin {montakoPerattaista} perättäistä klaavaa saatiin heittämällä {keskimaarainenHeittojenMaara} heittoa");

    }

    /// <summary>
    /// Montako heittoa tarvitaan että saadaan tietty määrä klaavoja peräjälkeen.
    /// </summary>
    /// <param name="montakoPerattaista">Montako perättäistä klaavaa halutaan</param>
    /// <returns>Heittojen määrä yhteensä</returns>
    public static int MontakoHeittoaTarvitaan(int montakoPerattaista)
    {
        int klaavojaPerakkain = 0;
        int heittoja = 0;
        while (klaavojaPerakkain < montakoPerattaista)
        {
            heittoja++;
            if (random.NextDouble() < 0.5) klaavojaPerakkain++;
            else klaavojaPerakkain = 0;
        }
        return heittoja;
    }
}
