using System;
using System.Collections.Generic;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Tehtävä 1.
/// </summary>
public class T1_PoistaPerattaiset
{
    /// <summary>
    /// Pääohjelma.
    /// </summary>
    public static void Main()
    {
        List<int> lista = new List<int> {0, 4, 7, 7, 7, 7, 7, 8, 2, 3, 8, 8};
        List<int> muokattu = PoistaPerattaiset(lista);
        Console.WriteLine("Alkuperäinen: " + string.Join(",", lista));
        Console.WriteLine("Muokattu: " + string.Join(",", muokattu));
    }


    /// <summary>
    /// Poista perättäiset samat alkiot
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <returns>Lista josta on poistettu samat perättäiset alkiot.</returns>
    /// <example>
    /// <pre name="test">
    /// String.Join(",", PoistaPerattaiset(new List<int>(new int[] {0,4,7,7,7,7,7,8,2,3,8,8}))) === "0,4,7,8,2,3,8"
    /// String.Join(",", PoistaPerattaiset(new List<int>(new int[] {3,3,3,4,5,5,5}))) === "3,4,5"
    /// String.Join(",", PoistaPerattaiset(new List<int>(new int[] {3,3,3,4,5,5}))) === "3,4,5"
    /// String.Join(",", PoistaPerattaiset(new List<int>(new int[] {5,8,2,4}))) === "5,8,2,4"
    /// String.Join(",", PoistaPerattaiset(new List<int>())) === ""
    /// List<int> lista = new List<int>(new int[] {3,3,3,4,5,5});
    /// PoistaPerattaiset(lista);
    /// String.Join(",", lista) === "3,3,3,4,5,5";
    /// </pre>
    /// </example>
    public static List<int> PoistaPerattaiset(List<int> luvut)
    {
        List<int> uusiLista = new List<int>();
        // Käydään luvut-lista silmukassa läpi
        // ja _aina_ kun törmätään sellaiseen alkioon
        // joka _ei_ ole sama kuin edellinen, niin lisätään
        // se uusiLista-listaan.
        for (int i = 0; i < luvut.Count; i++)
        {
            if (i == 0 || luvut[i] != luvut[i - 1])
            {
                uusiLista.Add(luvut[i]);
            }
        }
        return uusiLista;
    }


    /// <summary>
    /// Poista perättäiset samat alkiot.
    /// Tässä versiossa poistetaan uudesta listasta ei-toivotut alkiot. 
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <returns>Lista josta on poistettu samat perättäiset alkiot.</returns>
    /// <example>
    /// <pre name="test">
    /// String.Join(",", PoistaPerattaiset2(new List<int>(new int[] {0,4,7,7,7,7,7,8,2,3,8,8}))) === "0,4,7,8,2,3,8"
    /// String.Join(",", PoistaPerattaiset2(new List<int>(new int[] {3,3,3,4,5,5,5}))) === "3,4,5"
    /// String.Join(",", PoistaPerattaiset2(new List<int>(new int[] {3,3,3,4,5,5}))) === "3,4,5"
    /// String.Join(",", PoistaPerattaiset2(new List<int>(new int[] {5,8,2,4}))) === "5,8,2,4"
    /// String.Join(",", PoistaPerattaiset2(new List<int>())) === ""
    /// List<int> lista = new List<int>(new int[] {3,3,3,4,5,5});
    /// PoistaPerattaiset2(lista);
    /// String.Join(",", lista) === "3,3,3,4,5,5";
    /// </pre>
    /// </example>
    public static List<int> PoistaPerattaiset2(List<int> luvut)
    {
        List<int> muokattu = new List<int>(luvut);
        if (luvut.Count == 0) return muokattu;
        int i = 1;
        while (i < muokattu.Count)
        {
            if (muokattu[i] == muokattu[i - 1]) muokattu.RemoveAt(i);
            else i++;
        }
        return muokattu;
    }
}
