using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Tehtävä 2. Ohjelma karkausvuosien selvittämistä varten.
/// </summary>
public class T2_Karkausvuosi
{
    /// <summary>
    /// Pääohjelma.
    /// </summary>
    public static void Main()
    {
        Console.WriteLine($"Onko 1900 karkausvuosi? {Karkausvuosi(1900)}");
        Console.WriteLine($"Onko 2000 karkausvuosi? {Karkausvuosi(2000)}");
        Console.WriteLine($"Onko 2001 karkausvuosi? {Karkausvuosi(2001)}");
        Console.WriteLine($"Onko 2004 karkausvuosi? {Karkausvuosi(2004)}");
        Console.WriteLine($"Onko 2025 karkausvuosi? {Karkausvuosi(2025)}");
    }

    /// <summary>
    /// Tutkitaan onko vuosi karkausvuosi vai ei.    
    /// Karkausvuosi on sellainen neljällä jaollinen vuosi, joka
    /// ei ole sadalla jaollinen, paitsi jos vuosi on 400:lla jaollinen.
    /// </summary>
    /// <param name="vuosi">Tutkittava vuosi</param>
    /// <returns>Onko vuosi karkausvuosi</returns>
    /// <example>
    /// <pre name="test">
    /// Karkausvuosi(1899) === false;
    /// Karkausvuosi(1900) === false;
    /// Karkausvuosi(1904) === true;
    /// Karkausvuosi(1999) === false;
    /// Karkausvuosi(2000) === true;
    /// Karkausvuosi(2002) === false;
    /// Karkausvuosi(2004) === true;
    /// Karkausvuosi(2025) === true;
    /// </pre>
    /// </example>
    public static bool Karkausvuosi(int vuosi)
    {
        if (vuosi % 400 == 0) return true;
        if (vuosi % 100 == 0) return false;
        if (vuosi % 4 == 0) return true;
        return false;
    }


    /// <summary>
    /// Tutkitaan onko vuosi karkausvuosi vai ei.    
    /// Karkausvuosi on sellainen neljällä jaollinen vuosi, joka
    /// ei ole sadalla jaollinen, paitsi jos vuosi on 400:lla jaollinen.
    /// Tämä versio on hankalammin luettava ja siksi ei suositeltava. 
    /// </summary>
    /// <param name="vuosi">Tutkittava vuosi</param>
    /// <returns>Onko vuosi karkausvuosi</returns>
    /// <example>
    /// <pre name="test">
    /// Karkausvuosi2(1899) === false;
    /// Karkausvuosi2(1900) === false;
    /// Karkausvuosi2(1904) === true;
    /// Karkausvuosi2(1999) === false;
    /// Karkausvuosi2(2000) === true;
    /// Karkausvuosi2(2002) === false;
    /// Karkausvuosi2(2004) === true;
    /// Karkausvuosi2(2021) === false;
    /// </pre>
    /// </example>
    public static bool Karkausvuosi2(int vuosi)
    {
        if (vuosi % 4 == 0)
        {
            if (vuosi % 100 == 0 && vuosi % 400 != 0) { return false; }
            else return true;
        }
        else return false;
    }
}
