using Jypeli;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Tehtävä 5. Toiston poisto.
/// </summary>
public class T5_ToistonPoisto : PhysicsGame
{

    /// <summary>
    /// Pääohjelma.
    /// </summary>
    public override void Begin()
    {
        LuoSeina(50);
        PhysicsObject katto = LuoKatto(50);
        katto.Y = 50;

        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }


    /// <summary>
    /// Luo yleisen rakenteen fysiikkaolion ja palauttaa sen.
    /// </summary>
    /// <param name="leveys">Rakenteen leveys</param>
    /// <param name="korkeus">Rakenteen korkeus</param>
    /// <param name="vari">Rakenteen väri</param>
    /// <returns>Luotu fysiikkaolio</returns>
    private PhysicsObject LuoRakenne(double leveys, double korkeus, Color vari)
    {
        PhysicsObject rakenne = new PhysicsObject(leveys, korkeus);
        rakenne.Tag = "rakenne";
        rakenne.Color = vari;
        Add(rakenne);
        return rakenne;
    }


    /// <summary>
    /// Luo seinän ja palauttaa sen.
    /// </summary>
    /// <returns>Seinä-fysiikkaolio</returns>
    private PhysicsObject LuoSeina(double koko)
    {
        return LuoRakenne(koko, koko, Color.Blue);
    }


    /// <summary>
    /// Luo katon ja palauttaa sen.
    /// </summary>
    /// <returns>Katto-fysiikkaolio</returns>
    private PhysicsObject LuoKatto(double koko)
    {
        return LuoRakenne(koko * 1.5, koko, Color.Red);
    }
}
