using Jypeli;


/// <summary>
/// Tehtävä 6 (pohjatiedosto).
/// </summary>
public class T6_ToistonPoistoPohja : PhysicsGame
{
    /// <summary>
    /// Pelaaja 1
    /// </summary>
    PhysicsObject pelaaja1;

    /// <summary>
    /// Pelikentän leveys
    /// </summary>
    const double KENTANLEVEYS = 800.0;

    /// <summary>
    /// Pelikentän korkeus
    /// </summary>
    const double KENTANKORKEUS = 600.0;

    /// <summary>
    /// Pelivälineiden luonti
    /// </summary>
    public override void Begin()
    {
        Level.Size = new Vector(KENTANLEVEYS, KENTANKORKEUS);
        Level.Background.Image = Image.CreateStarSky((int)KENTANLEVEYS, (int)KENTANKORKEUS, 10000);
        SetWindowSize(800, 600, false);

        pelaaja1 = new PhysicsObject(120, 60, Shape.CreateRegularPolygon(5));
        pelaaja1.Mass = 1.0;
        Add(pelaaja1);

        pelaaja1.LinearDamping = 0.9; // Hidastaa pelaajan liikettä kiihdyttämisen jälkeen
        pelaaja1.AngularDamping = 0.95;

        Keyboard.Listen(Key.Left, ButtonState.Down, KaannaPelaaja1Vasemmalle, "Käänny vasemmalle");
        Keyboard.Listen(Key.Right, ButtonState.Down, KaannaPelaaja1Oikealle, "Käänny oikealle");
        Keyboard.Listen(Key.Up, ButtonState.Down, KiihdytaPelaaja1, "Kiihdytä pelaajaa 1");
        Keyboard.Listen(Key.F1, ButtonState.Pressed, ShowControlHelp, null);
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }

    /// <summary>
    /// Kääntää pelaajaa 1 vasemmalle
    /// </summary>
    private void KaannaPelaaja1Vasemmalle()
    {
        pelaaja1.Angle += Angle.FromDegrees(2);
    }

    /// <summary>
    /// Kääntää pelaajaa 1 oikealle
    /// </summary>
    private void KaannaPelaaja1Oikealle()
    {
        pelaaja1.Angle -= Angle.FromDegrees(2);
    }

    /// <summary>
    /// Kiihdyttää pelaajaa 1
    /// </summary>
    private void KiihdytaPelaaja1()
    {
        // Vector.FromLengthAndAngle-metodi luo
        // vektorin annetusta pituudesta ja kulmasta
        // Näin saadaan pelaaja kulkemaan aina "eteenpäin"
        pelaaja1.Push(Vector.FromLengthAndAngle(300, pelaaja1.Angle));
    }
}

