using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/// @author Antti-Jussi Lakanen
/// @version 2021
/// <summary>
/// Bonus 4. Ohjelmassa harjoitellaan kokonaislukutaulukon
/// sekoittamista ja tulostamista.
/// </summary>
public class B4_Sekoitus
{
    /// <summary>
    /// Muuttujien alustus ja aliohjelmakutsut.
    /// </summary>
    /// <param name="args"></param>
    public static void Main(string[] args)
    {
        int[] luvut = new int[52];

        for (int i = 0; i < luvut.Length; i++)
        {
            luvut[i] = i + 1;
        }

        TulostaTaulukko(luvut);
        SekoitaTaulukko(luvut);
        TulostaTaulukko(luvut);
    }

    /// <summary>
    /// Aliohjelma sekoittaa annetun kokonaislukutaulukon
    /// alkiot keskenään Fisher-Yates-algoritmilla
    /// (aikavaativuus n).
    /// http://en.wikipedia.org/wiki/Fisher%E2%80%93Yates_shuffle#The_modern_algorithm
    /// </summary>
    /// <param name="luvut">Sekoitettava taulukko.</param>
    public static void SekoitaTaulukko(int[] luvut)
    {
        Random r = new Random();

        for (int i = luvut.Length - 1; i > 0; i--)
        {
            int j = r.Next(i);
            int apu = luvut[j];
            luvut[j] = luvut[i];
            luvut[i] = apu;
        }
    }

    /// <summary>
    /// Tulostaa int-taulukon.
    /// </summary>
    /// <param name="luvut">Taulukko.</param>
    public static void TulostaTaulukko(int[] luvut)
    {
        foreach (int luku in luvut) Console.Write(luku + " ");
        Console.WriteLine();
    }
}