using Jypeli;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Tehtävä 2. Piirrellään neliöitä. 
/// </summary>
public class T2_Laatikot : PhysicsGame
{
    /// <summary>
    /// Neliön sivun pituus.
    /// </summary>
    const double SIVUN_PITUUS = 80.0;

    /// <summary>
    /// Piirtää yhden neliön ja palauttaa 
    /// neliön oikean ylänurkan koordinaatit.
    /// </summary>
    /// <param name="vasenAlareuna">Neliön vasen alanurkka.</param>
    /// <returns>Neliön oikea ylänurkka.</returns>
    private Vector PiirraNelio(Vector vasenAlareuna)
    {
        // Laatikon keskipiste on "puolessavälissä" laatikon leveyttä ja korkeutta
        double keskiPisteX = vasenAlareuna.X + SIVUN_PITUUS / 2;
        double keskiPisteY = vasenAlareuna.Y + SIVUN_PITUUS / 2;
        Vector keskipiste = new Vector(keskiPisteX, keskiPisteY);
        GameObject nelio = new GameObject(SIVUN_PITUUS, SIVUN_PITUUS);
        nelio.Position = keskipiste;
        // Tai lyhyemmin: 
        // nelio.Position = vasenAlareuna + new Vector(LAATIKON_KOKO / 2, LAATIKON_KOKO / 2);
        Add(nelio);
        double oikeanYlareunanX = keskiPisteX + SIVUN_PITUUS / 2;
        double oikeanYlareunanY = keskiPisteY + SIVUN_PITUUS / 2;
        return new Vector(oikeanYlareunanX, oikeanYlareunanY);
        // Tai lyhyemmin:
        // return nelio.Position + new Vector(LAATIKON_KOKO / 2, LAATIKON_KOKO / 2);
    }


    /// <summary>
    /// Alustukset ja aliohjelmakutsut.
    /// </summary>
    public override void Begin()
    {
        Vector piste = new Vector(0, 0);
        piste = PiirraNelio(piste);
        piste = PiirraNelio(piste);
        piste = PiirraNelio(piste);

        GameObject punainenPallo = new GameObject(10, 10, Shape.Circle);
        punainenPallo.Position = new Vector(0, 0);
        punainenPallo.Color = Color.Red;
        Add(punainenPallo, 1);

        Camera.ZoomToAllObjects(100);
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }
}
