using System;
using System.Collections.Generic;

/// <summary>
/// Tehtävä 5.
/// </summary>
public class EtsiJaPoistaPisin
{
    /// <summary>
    /// Muuttujien alustukset, aliohjelmakutsut.
    /// </summary>
    /// <param name="args"></param>
    public static void Main(string[] args)
    {
        List<string> jonot = new List<string>();
        jonot.Add("a"); jonot.Add("bb"); jonot.Add("a");
        jonot.Add("antti"); jonot.Add("antt"); jonot.Add("antti");
        Console.WriteLine("Lista sisältää seuraavat jonot:\n");
        TulostaLista(jonot);

        // KOHTA 1
        string pisinJono = PisinJono(jonot);
        Console.WriteLine($"Pisin merkkijono on {pisinJono}");

    }

    /// <summary>
    /// Poista listasta kaikki toisen parametrin mukaiset sanat.
    /// </summary>
    /// <param name="jonot"></param>
    /// <param name="poistettava"></param>
    /// <example>
    /// <pre name="test">
    /// List<string> jonot = new List<string>();
    /// PisinJono(jonot) === "";
    /// jonot.Add("");
    /// PisinJono(jonot) === "";
    /// jonot.Add("a"); jonot.Add("bb"); jonot.Add("a");
    /// jonot.Add("antti"); jonot.Add("antt"); jonot.Add("antti");
    /// PoistaJonot(jonot, "a");
    /// String.Join(',', jonot) === ",bb,antti,antt,antti";
    /// PoistaJonot(jonot, "antti");
    /// String.Join(',', jonot) === ",bb,antt";
    /// </pre>
    /// </example>
    public static void PoistaJonot(List<string> jonot, string poistettava)
    {
        while (true)
        {
            bool poistettiinko = jonot.Remove(poistettava);
            if (!poistettiinko) break;
        }
    }


    /// <summary>
    /// Poista listasta kaikki toisen parametrin mukaiset sanat.
    /// </summary>
    /// <param name="jonot"></param>
    /// <param name="poistettava"></param>
    public static void PoistaSanat2(List<string> jonot, string poistettava)
    {
        int i = 0;
        while (i < jonot.Count)
        {
            if (jonot[i] == poistettava) jonot.RemoveAt(i);
            else i++;
        }
    }


    /// <summary>
    /// Palauttaa listan pisimmän merkkijonon. Listan ollessa tyhjä palautetaan
    /// tyhjä merkkijono.
    /// </summary>
    /// <param name="jonot">Lista, josta pisintä merkkijonoa etsitään.</param>
    /// <returns>Pisin merkkijono.</returns>
    /// <example>
    /// <pre name="test">
    /// List<String> jonot = new List<String>();
    /// PisinJono(jonot) === "";
    /// jonot.Add("");
    /// PisinJono(jonot) === "";
    /// jonot.Add("a"); jonot.Add("bb"); jonot.Add("a");
    /// jonot.Add("antti"); jonot.Add("antt"); jonot.Add("antti");
    /// PisinJono(jonot) === "antti";
    /// </pre>
    /// </example>
    public static String PisinJono(List<String> jonot)
    {
        string pisinJono = "";
        foreach (String jono in jonot)
        {
            if (jono.Length > pisinJono.Length)
            {
                pisinJono = jono;
            }
        }
        return pisinJono;
    }

    /// <summary>
    /// Tulostaa annetun listan merkkijonoista.
    /// </summary>
    /// <param name="jonot">Tulostettava lista.</param>
    public static void TulostaLista(List<String> jonot)
    {
        foreach (String jono in jonot) Console.WriteLine("\"" + jono + "\"");
    }
}
