using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Text;


/// <summary>
/// Bonus 3-4. Ohjelmassa luetaan valuuttakursseja tiedostosta ja tulostetaan
/// niista kayttajan antama valuutta.
/// </summary>
public class B12_Valuutat
{
    /// <summary>
    /// Luetaan valuutat-tiedosto ja
    /// pyydetään käyttäjältä syöte ja tulostellaan 
    /// tuloksia sen mukaan.
    /// </summary>
    /// <param name="args">ei käytössä</param>
    public static void Main(string[] args)
    {
        string[] valuuttalista;
        try
        {
            valuuttalista = File.ReadAllLines("valuutat.xls");
        }
        catch (IOException ex)
        {
            Console.Error.WriteLine("Virhe: " + ex.Message);
            return;
        }

        KyseleValuuttoja(valuuttalista);
    }


    /// <summary>
    /// Kysellään käyttäjältä valuuttoja kunnes annetaan tyhjä rivi
    /// </summary>
    /// <param name="valuuttalista">Lista josta valuuttoja etsitään</param>
    public static void KyseleValuuttoja(IList<string> valuuttalista)
    {
        while (true)
        {
            Console.Write("Anna valuutta >");
            string valuutta = Console.ReadLine();
            if (valuutta.Length == 0) break;
            TulostaValuutta(valuuttalista, valuutta);
        }
    }


    /// <summary>
    /// Tulostetaan valuutta, joka vastaa hakujonoa valuutta
    /// </summary>
    /// <param name="valuuttalista">Valuutat</param>
    /// <param name="valuutta">etsittävä valuutta</param>
    public static void TulostaValuutta(IList<string> valuuttalista, string valuutta)
    {
        string isolla = valuutta.ToUpper();
        
        foreach (string v in valuuttalista)
        {                              
            // huomaa, etta valuutta voi olla
            // muukin kuin valuuttatunnuksen.
            if (v.Contains(isolla))  
            {
                string[] tiedot = v.Split(',');
                // Erottelun jälkeen tiedot ovat järjestyksessä: 
                // 0: Valuuttatunnus
                // 1: Keskikurssi
                // 2: Myynti
                // 3: Osto
                // 4: Ajankohta
                Console.WriteLine($"{tiedot[0]}: Keskikurssi {double.Parse(tiedot[1])}. Myynti {double.Parse(tiedot[2])}. Osto {double.Parse(tiedot[3])}. ({tiedot[4]})");
            }
        }                              
    }
}