using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;
using System.Net;
using System.Net.Http;
using System.Text.RegularExpressions;

/// @author Antti-Jussi Lakanen
/// @author Vesa Lappalainen
/// @version kevät 2011
/// @version 06.11.2015
/// @version 2025 HttpClient-olio
/// <summary>
/// 
/// </summary>
public class G1_2_ValuutatNetista
{
    /// <summary>
    /// Paaohjelmassa haetaan tiedot netista ja pyydetaan kayttajalta valuutta jota
    /// halutaan tarkastella.
    /// </summary>
    public static void Main()
    {
        string url = "https://tim.jyu.fi/files/183746/commercialTransaction.xls";
        List<string> lista = LueNetistaListaan(url);
        B12_Valuutat.KyseleValuuttoja(lista);
    }

    /// <summary>
    /// Luetaan annetun url-osoitteen koko html-koodi
    /// ja laitetaan rivi kerrallaan string-listaan.
    /// </summary>
    /// <param name="url">URL-osoite, mika halutaan lukea.</param>
    /// <returns>luettu lista</returns>
    public static List<string> LueNetistaListaan(string url)
    {
        List<string> lista = new List<string>();
        string sisalto = "";
        try
        {
            HttpClient client = new HttpClient();
            sisalto = client.GetStringAsync(url).GetAwaiter().GetResult();
            
        }
        catch (NotSupportedException e) { Console.WriteLine(e.Message); }
        catch (HttpRequestException e) { Console.WriteLine(e.Message); }

        lista = sisalto.Split("\r\n",StringSplitOptions.RemoveEmptyEntries).ToList();
        return lista;
    }
}