using System;
using System.Linq;
using System.IO;
using Microsoft.CodeAnalysis;
using Microsoft.CodeAnalysis.CSharp;
using Microsoft.CodeAnalysis.CSharp.Syntax;
using System.Linq;
using System.Reflection;

/// @author Omanimi
/// @version 02.08.2025
/// <summary>
/// 
/// </summary>
public class T1_Rekursio1_Tarkistaja
{
    /// <summary>
    /// 
    /// </summary>
    public static void Main()
    {
        // Path to the student's code file
        //string filePath = "Rekursio1.cs";
        string filePath = "T1-Rekursio1.cs";

        if (!File.Exists(filePath))
        {
            Console.WriteLine("File not found: " + filePath);
            return;
        }

        string code = File.ReadAllText(filePath);

        var tree = CSharpSyntaxTree.ParseText(code);
        var root = tree.GetRoot();

        var methodDeclarations = root.DescendantNodes().OfType<MethodDeclarationSyntax>();

        Console.WriteLine("Kutsulla TulostaNollaanSaakka(5) Ohjelmasi tulostaa:");
        T1_Rekursio1.TulostaNollaanSaakka(5);
        
        foreach (var method in methodDeclarations)
        {
            var methodName = method.Identifier.Text;
            var callsItself = method.DescendantNodes()
                .OfType<InvocationExpressionSyntax>()
                .Any(invocation => invocation.Expression.ToString() == methodName);

            var usesLoops = method.DescendantNodes()
                .OfType<StatementSyntax>()
                .Any(stmt => stmt is ForStatementSyntax ||
                             stmt is WhileStatementSyntax ||
                             stmt is DoStatementSyntax ||
                             stmt is ForEachStatementSyntax);

            Console.WriteLine($"Method: {methodName}");
            Console.WriteLine($"  Calls itself (Recursion): {callsItself}");
            Console.WriteLine($"  Uses loops (Iteration): {usesLoops}");
        }
    }
}