using System;
using System.Collections.Generic;

/// <summary>
/// Tehtävä 4. Ohjelma arpoo 7 numeroa ja 3 varanumeroa 40:stä.
/// </summary>
public class T4_Lotto
{
    const int PALLOJA = 40;
    const int ONNENNUMEROITA = 7;
    const int LISANUMEROITA = 3;

    /// <summary>
    /// Alustukset ja kutsut. 
    /// </summary>
    /// <param name="args"></param>
    public static void Main(string[] args)
    {
        List<int> pallot = new List<int>();
        for (int i = 0; i < PALLOJA; i++)
        {
            pallot.Add(i + 1);
        }

        SekoitaLista(pallot);

        Console.Write("Onnennumerot: ");

        for (int i = 0; i < ONNENNUMEROITA; i++)
        {
            Console.Write(pallot[i] + " ");
        }
        // Tai vaihtoehtoisesti: 
        // TulostaLista(pallot.GetRange(0, ONNENNUMEROITA));

        Console.WriteLine();

        Console.Write("Lisänumerot: ");

        for (int i = ONNENNUMEROITA; i < ONNENNUMEROITA + LISANUMEROITA; i++)
        {
            Console.Write(pallot[i] + " ");
        }
        // Tai vaihtoehtoisesti: 
        // TulostaLista(pallot.GetRange(ONNENNUMEROITA, LISANUMEROITA));

        Console.WriteLine();
    }

    /// <summary>
    /// Aliohjelma sekoittaa annetun kokonaislukulistan
    /// alkiot keskenään Fisher-Yates-algoritmilla
    /// (aikavaativuus n).
    /// http://en.wikipedia.org/wiki/Fisher%E2%80%93Yates_shuffle#The_modern_algorithm
    /// </summary>
    /// <param name="luvut">Sekoitettava lista.</param>
    public static void SekoitaLista(List<int> luvut)
    {
        Random r = new Random();

        for (int i = luvut.Count - 1; i > 0; i--)
        {
            int j = r.Next(i);
            int apu = luvut[j];
            luvut[j] = luvut[i];
            luvut[i] = apu;
        }
    }

    /// <summary>
    /// Tulostaa <code>List<int></code>-tietorakenteen
    /// alkiot peräjälkeen välilyönnillä erotettuna.
    /// </summary>
    /// <param name="lista">Tulostettava lista</param>
    public static void TulostaLista(List<int> lista)
    {
        foreach (int alkio in lista) Console.Write(alkio + " ");
        Console.WriteLine();
    }
}