using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

///@author Antti-Jussi Lakanen
///@version 2025
///
/// <summary>
/// Tehtävä 6. Muutetaan merkkijonoja liukuluvuksi.
/// </summary>
public class T6_Poikkeukset
{
    /// <summary>
    /// Paaohjelmassa kutsutaan aliohjelmia ja tulostetaan.
    /// </summary>
    public static void Main()
    {
        double d1 = MuutaJono("12,3", 0.0); // desimaalimerkki   
        // käyttöjärjestelmän mukaan, oletuksena suomenkielisissä windowseissa 
        // se on pilkku.
        double d2 = MuutaJono("12,3e", 0.0);
        double d3 = MuutaJono("kana", -1.0);
        double d4 = MuutaJono(null, 0.0);
        Console.WriteLine($"{d1:0.00}, {d2:0.00}, {d3:0.00}, {d4:0.00}"); // 12,30 0,00 -1,00 0,00
    }


    /// <summary>
    /// Yritetaan muuttaa annettu merkkijono luvuksi.
    /// Tarvittaessa palautetaan oletusarvo.
    /// </summary>
    /// <param name="s">Muutettava jono</param>
    /// <param name="oletus">Luvun arvo, ellei muunnosyritys onnistu.</param>
    /// <returns>Palautettava luku</returns>
    /// <example>
    /// <pre name="test">
    /// MuutaJono("12.3", 0.0) === 12.3;
    /// MuutaJono("12.3e", 0.0) === 0.0;
    /// </pre>
    /// </example>
    public static double MuutaJono(string s, double oletus)
    {
        try
        {
            return (double.Parse(s));
        }
        catch (FormatException muotopoikkeus)
        {
            // Tyypillisesti näitä ei tulosteta käyttäjälle. 
            // Tulostus voidaan esimerkiksi ohjata Debug-tulosteeseen
            // (Debuggaustilassa Output -> Debug)
            Debug.WriteLine(muotopoikkeus.Message);
            return oletus;
        }
        catch (ArgumentNullException ae)
        {
            Debug.WriteLine(ae.Message);
            return oletus;
        }
    }
}